<template>
  <div class="contact-pop-up">
    <div @click="openContactModal">
      <img src="../../assets/contact.svg">
      <span>СВЯЗЬ</span>
    </div>
      <div class="contact-form-wrapper">
        <div :class="{'contact-form-open': showContactModal}">
          <transition name="fade">
            <div class="contact-form" >
              <div class="contact-form-header">
                <div><span>Напишите Нам</span> <span class="fa fa-minus" @click.stop="openContactModal"></span></div>

              </div>
              <div class="contact-form-body">
                <div class="form-group">
                  <label for="name">Имя</label>
                  <input type="text" class="main-input" :class="{'invalid': checkRequired(content.name)}" v-model="content.name" name="name" autocomplete="off">
                </div>

                <div class="form-group">
                  <label for="email">Электронная Почта</label>
                  <input type="text" class="main-input" :class="{'invalid': checkRequired(content.email, 'email')}" v-model="content.email" name="email" autocomplete="off">
                </div>
                <div class="form-group">
                  <label for="content">Сообщение</label>
                  <textarea v-model="content.message" class="form-control"></textarea>
                </div>
              </div>
              <div class="contact-form-footer">
                <div class="send-button" @click="sendMessage">
                  <div v-show="sending" class="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div>
                  <span v-if="!sending && !messageSent">Отправить <span class="send-icon"></span></span>
                  <span v-if="!sending && messageSent">Отправлено <span class="checked"></span></span>
                </div>
              </div>
            </div>
          </transition>
        </div>
      </div>
  </div>
</template>
<script>
export default {
  data() {
    return {
      showContactModal: false, showRequired: false, messageSent: false, sending: false,
      content: {
        name: '',
        email: '',
        message: ''
      }
    }
  },
  methods: {
    openContactModal, checkRequired, sendMessage
  }
}

function sendMessage() {
  let self = this;
  if (!this.content.email || !this.content.name || !this.content.message) {
    return this.showRequired = true;
  } else if (!validEmail(this.content.email)) {
    return this.showRequired = true;
  }
  this.sending = true;

  this.$http.post(`${process.env.VUE_APP_BASE_URL}/contact-form`, this.content).then(() => {
    this.sending = false;
    this.messageSent = true;
    Object.keys(this.content).forEach(k => {
      this.content[k] = '';
    });
  }).catch(err => {
    console.log(err);
  });
}

function validEmail(email) {
  var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
  return re.test(String(email).toLowerCase());
}

function checkRequired(i, type) {
  if (type === 'email') {
    return this.showRequired && !i || this.showRequired && !validEmail(i);
  }
  return this.showRequired && !i;
}

function openContactModal() {
  this.showContactModal = !this.showContactModal;
}
</script>
<style lang="scss">
  .contact-pop-up {
    height: 35px;
    position: fixed;
    z-index: 999;
    top: 85%;
    
    font-weight: 100;
    letter-spacing: 1.1px;

    & > div:first-child {
      opacity: 0.6;
      cursor: pointer;
      padding: 5px 10px;
      height: 35px;
      background-color: $maincolor;
      transform-origin: 0 50%;
      transform: rotate(-90deg) translate(-50%, 50%);
      display: flex;
    }
    .contact-form-wrapper {
      position: relative;
      width: 35px;
      & > div {
        position: relative;
        left: -400px;
        top: -370px;
        height: 400px;
        width: 320px;
        opacity: 0;
        transition: all 0.3s ease-in-out;
        .contact-form {
          position: absolute;
          height: 400px;
          width: 320px;
          color: #fff;
          .contact-form-header, .contact-form-footer {
            transition: all 0.3s ease-in-out;
            padding: 15px;
            opacity: 0.9;
            background-color: $maincolor;
          }
          .contact-form-header {
            padding-top: 10px;
            height: 50px;
            div {
              display: flex;
              justify-content: space-between;

              span:first-child {
                width: 70%;
                font-weight: 500;
                text-align: right;
              }
            }
            .fa {
              line-height: 27px;
              cursor: pointer;

              &:hover {
                -ms-transform: scale(1.2, 1.2); /* IE 9 */
                -webkit-transform: scale(1.2, 1.2); /* Safari prior 9.0 */
                transform: scale(1.2, 1.2); /* Standard syntax */
              }
            }
          }
          .contact-form-body {
            height: 300px;
            padding: 15px;
            border-left: 1px solid $maincolor;
            border-right: 1px solid $maincolor;
            background-color: #fff;
            transition: all 0.3s ease-in-out;
          }
          .contact-form-footer {
            height: 60px;
          }
          label {
            font-size: 16px;
            text-transform: uppercase;
            color: gray;
            margin-bottom: 0;
          }
          .main-input:focus {
            outline: none;
            box-shadow: -7px 10px 0px -7px $maincolor, 7px 10px 0px -7px $maincolor;
          }
          .main-input, textarea {
            font-size: 14px;
          }
          textarea {
            min-height: 100px;
          }
        }
        &.contact-form-open {
          display: block;
          opacity: 1;
          left: 40px;
        }

        .send-button {
          padding: 2px 10px;
          font-size: 16px;
          min-width: 145px;
          background-color: #fff;
          text-transform: uppercase;
          float: right;
          border-radius: 2px;
          cursor: pointer;
          text-align: center;
          span {
            color: gray;
            letter-spacing: 1.2px;
          }
          .send-icon {
            height: 15px;
            width: 15px;
            background-image: url('../../assets/paper-plane.svg');
            display: inline-block;
          }

          &:hover {
            background-color: #fbfbfb;
          }
        }
      }
    }
    span {
      color: #fff;
    }
    img {
      width: 25px;
      margin-right: 5px;
    }
  }
</style>